// Cancoffee: B O S S - Warning: Incoming Boss-strike -
//  by Murachue

#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "../hook/hook.h"
#include "strtable.h"

BOOL NowTraying = FALSE;

LRESULT CALLBACK DraghereButtonSubProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	if(msg == WM_APP)
	{
		SetWindowLong(hWnd, GWL_USERDATA, GetWindowLong(hWnd, GWL_WNDPROC));
		SetWindowLong(hWnd, GWL_WNDPROC, (LONG)DraghereButtonSubProc);
	}
	if(msg == WM_LBUTTONDOWN || msg == WM_LBUTTONDBLCLK)
	{
		SendMessage(GetParent(hWnd), WM_APP, 0, 0);
		return 0;
	}

	return CallWindowProc((WNDPROC)GetWindowLong(hWnd, GWL_USERDATA), hWnd, msg, wParam, lParam);
}

void waku(HWND hWnd)
{
	HDC hdc;
	HBRUSH holdbrs;
	HPEN holdpen;
	RECT rc;

	GetWindowRect(hWnd, &rc);
	hdc = GetWindowDC(hWnd);
	SetROP2(hdc, R2_NOT);

	holdpen = SelectObject(hdc, CreatePen(PS_INSIDEFRAME, 5, RGB(0, 0, 0)));
	holdbrs = SelectObject(hdc, GetStockObject(NULL_BRUSH));

	Rectangle(hdc, 0, 0, rc.right - rc.left, rc.bottom - rc.top);

	SelectObject(hdc, holdpen);
	SelectObject(hdc, holdbrs);

	ReleaseDC(hWnd, hdc);

	return;
}

void TrayAdd(HWND hWnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize = sizeof(nid);
	nid.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_TRAYICON));
	nid.hWnd = hWnd;
	lstrcpy(nid.szTip, AllocLoadString(IDS_CAMOTITLE));
	nid.uID = 0;
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nid.uCallbackMessage = WM_APP + 1;

	Shell_NotifyIcon(NIM_ADD, &nid);

	NowTraying = TRUE;

	return;
}

void TrayDelete(HWND hWnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize = sizeof(nid);
	nid.hWnd = hWnd;
	nid.uID = 0;
	nid.uFlags = 0;
	Shell_NotifyIcon(NIM_DELETE, &nid);

	NowTraying = FALSE;

	return;
}

void IncomingBoss(HWND hw, HWND hWndSender)
{
	if(!StartHook(hw))
	{
		MessageBox(NULL, TEXT("oops, hook failed."), NULL, MB_OK);
		return;
	}
	SendMessage(hw, WM_APP + 314, 0, (LPARAM)hWndSender);
	SendMessage(hw, WM_SYSCOMMAND, SC_MINIMIZE, 0);

	return;
}

BOOL CALLBACK ConfigDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static UINT WmTaskbarCreated;

	switch(msg)
	{
	case WM_INITDIALOG:
		WmTaskbarCreated = RegisterWindowMessage(TEXT("TaskbarCreated"));
		DraghereButtonSubProc(GetDlgItem(hWnd, IDC_DRAGHERE), WM_APP, 0, 0);
		SetTimer(hWnd, 0, 100, NULL);
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			TrayAdd(hWnd);
			ShowWindow(hWnd, SW_HIDE);
			break;
		case IDCANCEL:
			if(NowTraying)
				TrayDelete(hWnd);
			if(QueryHookState())
				SendMessage(QueryHookWnd(), WM_APP + 315, 0, 0);
			KillTimer(hWnd, 0);
			PostQuitMessage(0);
			break;
		case IDC_HOTKEY:
			{
				LRESULT key;

				UnregisterHotKey(hWnd, 0);
				key = SendMessage(GetDlgItem(hWnd, IDC_HOTKEY), HKM_GETHOTKEY, 0, 0);
				if(LOBYTE(key))
				{
					if(!RegisterHotKey(hWnd, 0, (HIBYTE(key) & HOTKEYF_SHIFT ? MOD_SHIFT : 0) | (HIBYTE(key) & HOTKEYF_CONTROL ? MOD_CONTROL : 0) | (HIBYTE(key) & HOTKEYF_ALT ? MOD_ALT : 0), LOBYTE(key)))
					{
						MessageBox(hWnd, TEXT("Hotkey plant failed"), TEXT("Error"), MB_ICONERROR | MB_OK);
					}
				}
			}
			break;
		case IDC_HWND:
			{
				TCHAR ts[64];
				HWND hw;

				hw = (HWND)GetDlgItemInt(hWnd, IDC_HWND, NULL, FALSE);

				ts[0] = TEXT('\0');
				GetClassName(hw, ts, sizeof(ts));
				SetDlgItemText(hWnd, IDC_WNDCLASS, ts);

				ts[0] = TEXT('\0');
				GetWindowText(hw, ts, sizeof(ts));
				SetDlgItemText(hWnd, IDC_CAPTION, ts);
			}
			break;
		case IDC_SELACTIVE:
			if(SendMessage(GetDlgItem(hWnd, IDC_SELACTIVE), BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hWnd, IDC_HWND), FALSE);
			}else
			{
				EnableWindow(GetDlgItem(hWnd, IDC_HWND), TRUE);
			}
			break;
		}
		break;
	case WM_APP + 1:
		if(lParam == WM_RBUTTONUP)
		{
			HMENU hm;
			int ret;
			POINT p;

			hm = CreatePopupMenu();
			InsertMenu(hm, 0, MF_BYPOSITION, 1, AllocLoadString(IDS_CAMOSHOW));
			InsertMenu(hm, 1, MF_BYPOSITION, 3, AllocLoadString(IDS_CAMOFREE));
			InsertMenu(hm, 2, MF_BYPOSITION, 2, AllocLoadString(IDS_CAMOEXIT));

			GetCursorPos(&p);

			SetForegroundWindow(hWnd);
			ret = (int)TrackPopupMenu(hm, TPM_RETURNCMD, p.x, p.y, 0, hWnd, NULL);

			switch(ret)
			{
			case 1:
				ShowWindow(hWnd, SW_SHOW);
				TrayDelete(hWnd);
				break;
			case 2:
				SendMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
				break;
			case 3:
				if(QueryHookState())
					SendMessage(QueryHookWnd(), WM_APP + 315, 0, 0);
				break;
			}
		}
		if(lParam == WM_LBUTTONDBLCLK)
		{
			ShowWindow(hWnd, SW_SHOW);
			TrayDelete(hWnd);
		}
		break;
	case WM_APP:
		SetCursor(LoadCursor(NULL, IDC_CROSS));
		SetCapture(hWnd);
		SetWindowLong(hWnd, GWL_USERDATA, 0);
		break;
	case WM_MOUSEMOVE:
		if(GetCapture() == hWnd)
		{
			POINT p;
			HWND hw, oldhw;

			GetCursorPos(&p);
			hw = WindowFromPoint(p);
			oldhw = (HWND)GetWindowLong(hWnd, GWL_USERDATA);

			while(GetWindowLong(hw, GWL_STYLE) & WS_CHILD)
			{
				hw = GetParent(hw);
			}

			if(oldhw != hw)
			{
				if(oldhw)
					waku(oldhw);
				waku(hw);
				SetWindowLong(hWnd, GWL_USERDATA, (LONG)hw);

				SetDlgItemInt(hWnd, IDC_HWND, (UINT)hw, FALSE);
#if 0
				{
					TCHAR ts[64];

					wsprintf(ts, "%d", hw);
					SetDlgItemText(hWnd, IDC_HWND, ts);

					/*
					GetClassName(hw, ts, 63);
					SetDlgItemText(hWnd, IDC_WNDCLASS, ts);

					GetWindowText(hw, ts, 63);
					SetDlgItemText(hWnd, IDC_CAPTION, ts);
					*/
				}
#endif
			}
		}
		break;
	case WM_LBUTTONUP:
		if(GetCapture() == hWnd)
		{
			HWND hw;

			SetCursor(LoadCursor(NULL, IDC_ARROW));
			ReleaseCapture();

			hw = (HWND)GetWindowLong(hWnd, GWL_USERDATA);

			if(hw)
			{
				waku(hw);
			}
		}
		break;
	case WM_HOTKEY:
		if(!QueryHookState())
		{
			HWND hw;

			hw = (HWND)GetDlgItemInt(hWnd, IDC_HWND, NULL, FALSE);

			if(IsWindow(hw))
				IncomingBoss(hw, hWnd);
		}else
		{
			HWND hw = QueryHookWnd();

			SendMessage(hw, WM_APP + 315, 0, 0);
			if(IsIconic(hw))
			{
				ShowWindow(hw, SW_RESTORE);
				SetForegroundWindow(hw);
			}
		}
		break;
	case WM_APP + 320:
		if(NowTraying)
		{
			NOTIFYICONDATA nid;

			nid.cbSize = sizeof(nid);
			nid.uID = 0;
			nid.hWnd = hWnd;
			nid.uFlags = NIF_ICON;
			nid.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_TRAYIACT));

			Shell_NotifyIcon(NIM_MODIFY, &nid);
		}
		break;
	case WM_APP + 321:
		if(NowTraying)
		{
			NOTIFYICONDATA nid;

			nid.cbSize = sizeof(nid);
			nid.uID = 0;
			nid.hWnd = hWnd;
			nid.uFlags = NIF_ICON;
			nid.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_TRAYICON));

			Shell_NotifyIcon(NIM_MODIFY, &nid);
		}
		break;
#ifdef _DEBUG
	case WM_APP + 142:
		{
			TCHAR ts[64];

			wsprintf(ts, "(%04X)", QueryDebugVal());
			OutputDebugString(ts);
		}
		break;
	case WM_APP + 143:
		{
			OutputDebugString(QueryDebugStr());
		}
		break;
#endif
	case WM_TIMER:
		if(SendMessage(GetDlgItem(hWnd, IDC_SELACTIVE), BM_GETCHECK, 0, 0) == BST_CHECKED)
		{
			SetDlgItemInt(hWnd, IDC_HWND, (UINT)GetForegroundWindow(), FALSE);
		}
		break;
	default:
		if(msg == WmTaskbarCreated)
		{
			if(NowTraying)
				TrayAdd(hWnd);
		}
	}

	return FALSE;
}

void WinMainCRTStartup(void)
{
	MSG msg;
	HWND cwnd;

	// InitCommonControlȂĂȂĂDialogɂĂEEE?

	cwnd = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_CONFIG), NULL, ConfigDlgProc);
	ShowWindow(cwnd, SW_SHOW);

	while(GetMessage(&msg, NULL, 0, 0))
	{
		if(IsDialogMessage(cwnd, &msg))
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	FreeLoadedStrings();

	ExitProcess(msg.wParam);
}
